# NOTE: Derived from blib/lib/PerlBean/Attribute/Multi/Ordered.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package PerlBean::Attribute::Multi::Ordered;

#line 470 "blib/lib/PerlBean/Attribute/Multi/Ordered.pm (autosplit into blib/lib/auto/PerlBean/Attribute/Multi/Ordered/create_method_pop.al)"
sub create_method_pop {
    my $self = shift;

    my $an = $self->get_method_factory_name();
    my $an_esc = $self->_esc_aq($an);
    my $op = &{$MOF}('pop');
    my $mb = $self->get_method_base();
    my $ec = $self->get_exception_class();
    my $pkg = $self->get_package();
    my $pkg_us = $self->get_package_us();
    my $desc = defined( $self->get_short_description() ) ? $self->get_short_description() : 'not described option';
    my $empt = $self->is_allow_empty() ? '' : ' After popping at least one element must remain.';
    my $exc = ' On error an exception C<' . $self->get_exception_class() . '> is thrown.';

    # Make body
    my $body = <<EOF;
${IND}my \$self${AO}=${AO}shift;

EOF

    # Check if list value is allowed to be empty
    if (! $self->is_allow_empty()) {
        $body .= <<EOF;
${IND}# List value for $an_esc is not allowed to be empty
${IND}(scalar${BFP}(\@_)${AO}>${AO}1)${AO}||${AO}throw $ec${BFP}("ERROR: ${pkg}::$op$mb, list value may not be empty.");

EOF
    }

    # Method tail
    $body .= <<EOF;
${IND}# Pop an element from the list
${IND}return${BFP}(${ACS}pop${BFP}(${ACS}\@{${ACS}\$self->{$pkg_us}{$an}${ACS}}${ACS})${ACS});
EOF

    # Create and return the method
    return( PerlBean::Method->new( {
        method_name => "$op$mb",
        documented => $self->is_documented(),
        volatile => 1,
        description => <<EOF,
Pop and return an element off ${desc}.${empt}${exc}
EOF
        body => $body,
    } ) );
}

# end of PerlBean::Attribute::Multi::Ordered::create_method_pop
1;
