# NOTE: Derived from blib/lib/PerlBean/Attribute/Multi/Ordered.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package PerlBean::Attribute::Multi::Ordered;

#line 701 "blib/lib/PerlBean/Attribute/Multi/Ordered.pm (autosplit into blib/lib/auto/PerlBean/Attribute/Multi/Ordered/create_method_set_num.al)"
sub create_method_set_num {
    my $self = shift;

    my $an = $self->get_method_factory_name();
    my $an_esc = $self->_esc_aq($an);
    my $op = &{$MOF}('set_num');
    my $op_set_idx = &{$MOF}('set_idx');
    my $mb = $self->get_method_base();
    my $ec = $self->get_exception_class();
    my $pkg = $self->get_package();
    my $pkg_us = $self->get_package_us();
    my $desc = defined( $self->get_short_description() ) ? $self->get_short_description() : 'not described option';

    # Make body
    my $body = <<EOF;
${IND}my \$self${AO}=${AO}shift;
${IND}my \$num${AO}=${AO}shift;

EOF

    # Check if index is an integer
    $body .= <<EOF;
${IND}# Check if index is an integer
${IND}(${ACS}\$num${AO}==${AO}int${BFP}(\$num)${ACS})${AO}||${AO}throw $ec${BFP}("ERROR: ${pkg}::$op$mb, the specified number '\$num' is not an integer.");

EOF

    # Call $op_set_idx$mb
    $body .= <<EOF;
${IND}# Call $op_set_idx$mb
${IND}\$self->$op_set_idx$mb${BFP}(${ACS}\$num${AO}-${AO}1,${AC}\@_${ACS});
EOF

    # Make description
    my $description = <<EOF;
Set value in $desc. C<NUMBER> is the integer index which is greater than C<0>. C<VALUE> is the value.
EOF

    # Add clauses to the description
    my $clauses = $self->mk_doc_clauses();
    if ($clauses) {
        $description .= "\n" . $clauses;
    }

    # Create and return the method
    return( PerlBean::Method->new( {
        method_name => "$op$mb",
        parameter_description => "${ACS}NUMBER, VALUE${ACS}",
        documented => $self->is_documented(),
        volatile => 1,
        description => $description,
        body => $body,
    } ) );
}

# end of PerlBean::Attribute::Multi::Ordered::create_method_set_num
1;
