# NOTE: Derived from blib/lib/PerlBean.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package PerlBean;

#line 1033 "blib/lib/PerlBean.pm (autosplit into blib/lib/auto/PerlBean/_initialize.al)"
sub _initialize {
    my $self = shift;
    my $opt = defined($_[0]) ? shift : {};

    # Check $opt
    ref($opt) eq 'HASH' || throw Error::Simple("ERROR: PerlBean::_initialize, first argument must be 'HASH' reference.");

    # _export_tag_, MULTI
    if ( exists( $opt->{_export_tag_} ) ) {
        ref( $opt->{_export_tag_} ) eq 'ARRAY' || throw Error::Simple("ERROR: PerlBean::_initialize, specified value for option '_export_tag_' must be an 'ARRAY' reference.");
        $self->set__export_tag_( @{ $opt->{_export_tag_} } );
    }
    else {
        $self->set__export_tag_();
    }

    # _finalized_, BOOLEAN, with default value
    $self->set__finalized_( exists( $opt->{_finalized_} ) ? $opt->{_finalized_} : $DEFAULT_VALUE{_finalized_} );

    # _has_exports_, BOOLEAN, with default value
    $self->set__has_exports_( exists( $opt->{_has_exports_} ) ? $opt->{_has_exports_} : $DEFAULT_VALUE{_has_exports_} );

    # abstract, SINGLE
    exists( $opt->{abstract} ) && $self->set_abstract( $opt->{abstract} );

    # autoloaded, BOOLEAN, with default value
    $self->set_autoloaded( exists( $opt->{autoloaded} ) ? $opt->{autoloaded} : $DEFAULT_VALUE{autoloaded} );

    # base, MULTI
    if ( exists( $opt->{base} ) ) {
        ref( $opt->{base} ) eq 'ARRAY' || throw Error::Simple("ERROR: PerlBean::_initialize, specified value for option 'base' must be an 'ARRAY' reference.");
        $self->set_base( @{ $opt->{base} } );
    }
    else {
        $self->set_base();
    }

    # collection, SINGLE
    exists( $opt->{collection} ) && $self->set_collection( $opt->{collection} );

    # dependency, MULTI, with default value
    if ( exists( $opt->{dependency} ) ) {
        ref( $opt->{dependency} ) eq 'ARRAY' || throw Error::Simple("ERROR: PerlBean::_initialize, specified value for option 'dependency' must be an 'ARRAY' reference.");
        $self->set_dependency( @{ $opt->{dependency} } );
    }
    else {

        # Empty the dependency list
        $self->set_dependency();

        # Add 'use strict'
        $self->add_dependency( PerlBean::Dependency::Use->new( {
            dependency_name => 'strict',
        } ) );

        # Add 'use warnings'
        $self->add_dependency( PerlBean::Dependency::Use->new( {
            dependency_name => 'warnings',
        } ) );

        # Add 'use Error qw(:try)'
        $self->add_dependency( PerlBean::Dependency::Use->new( {
            dependency_name => 'Error',
            import_list => [ 'qw(:try)' ],
        } ) );

    }

    # description, SINGLE
    exists( $opt->{description} ) && $self->set_description( $opt->{description} );

    # exception_class, SINGLE, with default value
    $self->set_exception_class( exists( $opt->{exception_class} ) ? $opt->{exception_class} : $DEFAULT_VALUE{exception_class} );

    # export_tag_description, MULTI
    if ( exists( $opt->{export_tag_description} ) ) {
        ref( $opt->{export_tag_description} ) eq 'ARRAY' || throw Error::Simple("ERROR: PerlBean::_initialize, specified value for option 'export_tag_description' must be an 'ARRAY' reference.");
        $self->set_export_tag_description( @{ $opt->{export_tag_description} } );
    }
    else {
        $self->set_export_tag_description();
    }

    # license, SINGLE
    exists( $opt->{license} ) && $self->set_license( $opt->{license} );

    # method, MULTI
    if ( exists( $opt->{method} ) ) {
        ref( $opt->{method} ) eq 'ARRAY' || throw Error::Simple("ERROR: PerlBean::_initialize, specified value for option 'method' must be an 'ARRAY' reference.");
        $self->set_method( @{ $opt->{method} } );
    }
    else {
        $self->set_method();
    }

    # method_factory, MULTI
    if ( exists( $opt->{method_factory} ) ) {
        ref( $opt->{method_factory} ) eq 'ARRAY' || throw Error::Simple("ERROR: PerlBean::_initialize, specified value for option 'method_factory' must be an 'ARRAY' reference.");
        $self->set_method_factory( @{ $opt->{method_factory} } );
    }
    else {
        $self->set_method_factory();
    }

    # package, SINGLE, mandatory
    exists( $opt->{package} ) || throw Error::Simple("ERROR: PerlBean::_initialize, option 'package' is mandatory.");
    $self->set_package( $opt->{package} );

    # short_description, SINGLE, with default value
    $self->set_short_description( exists( $opt->{short_description} ) ? $opt->{short_description} : $DEFAULT_VALUE{short_description} );

    # singleton, BOOLEAN, with default value
    $self->set_singleton( exists( $opt->{singleton} ) ? $opt->{singleton} : $DEFAULT_VALUE{singleton} );

    # symbol, MULTI
    if ( exists( $opt->{symbol} ) ) {
        ref( $opt->{symbol} ) eq 'ARRAY' || throw Error::Simple("ERROR: PerlBean::_initialize, specified value for option 'symbol' must be an 'ARRAY' reference.");
        $self->set_symbol( @{ $opt->{symbol} } );
    }
    else {
        $self->set_symbol();
    }

    # synopsis, SINGLE
    exists( $opt->{synopsis} ) && $self->set_synopsis( $opt->{synopsis} );

    # use_perl_version, SINGLE, with default value
    $self->set_use_perl_version( exists( $opt->{use_perl_version} ) ? $opt->{use_perl_version} : $DEFAULT_VALUE{use_perl_version} );

    # Return $self
    return($self);
}

# end of PerlBean::_initialize
1;
